/**
 **	File ......... IWeb.h
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _IWEB_H
#define _IWEB_H

#define COOKIE_DOMAIN ".alhem.net"
#define COOKIE_PATH "/cgi-bin/ib"

#include <stdio.h>
#include <libcgi++.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <libibank.h>
#include "AccountForm.h"
#include "SettingsForm.h"
#include "ForumsForm.h"
#include "ThreadListForm.h"
#include "ViewThreadForm.h"
#include "NewThreadForm.h"
#include "NewMessageForm.h"
#include "EditMessageForm.h"


class IWeb : public Web
{
public:
	IWeb();
	~IWeb();

	void ReadCookies();
	void FormInput();
	void CreateHeader();
	void GenerateDocument();

	Database &GetDatabase() { return m_db; }
	void SetTheCookie();

/*
cookie =
 <usernum> : <valid> : <forum> : <thread> : <page> : <index> : <qty>
*/
	long GetUsernum() { return m_usernum; }
	void SetUsernum(long x) { if (x != m_usernum) m_bSetCookie = true; m_usernum = x; }
	long GetValid() { return m_valid; }
	void SetValid(long x) { if (x != m_valid) m_bSetCookie = true; m_valid = x; }
	long GetForum() { return m_forum; }
	void SetForum(long x) { if (x != m_forum) m_bSetCookie = true; m_forum = x; }
	long GetThread() { return m_thread; }
	void SetThread(long x) { if (x != m_thread) m_bSetCookie = true; m_thread = x; }
	long GetPage() { return m_page; }
	void SetPage(long x) { if (x != m_page) m_bSetCookie = true; m_page = x; }
	long GetIndex() { return m_index; }
	void SetIndex(long x) { if (x != m_index) m_bSetCookie = true; m_index = x; }
	long GetQty() { return m_qty; }
	void SetQty(long x) { if (x != m_qty) m_bSetCookie = true; m_qty = x; }
	long GetMessage() { return m_message; }
	void SetMessage(long x) { if (x != m_message) m_bSetCookie = true; m_message = x; }

private:
	Database m_db;
	SysLog m_log;
	bool m_bSetCookie;
	long m_image;
	db::Image *m_pImage;
	bool m_image_tn;
	bool m_not_modified;
	//
	AccountForm m_form1;
	SettingsForm m_form2;
	ForumsForm m_form3;
	ThreadListForm m_form4;
	ViewThreadForm m_form5;
	NewThreadForm m_form6;
	NewMessageForm m_form7;
	EditMessageForm m_form8;
	//
	long m_usernum;
	long m_valid;
	long m_forum;
	long m_thread;
	long m_page;
	long m_index;
	long m_qty;
	long m_message;
};




#endif // _IWEB_H
