/**
 **	File ......... SettingsForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include "SettingsForm.h"




SettingsForm::SettingsForm(Web *w) : BaseForm(w, "SettingsForm")
{
}


SettingsForm::~SettingsForm()
{
}


void SettingsForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="SettingsForm" value="action" ...
	if (!GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) || !*action)
	{
		return;
	}
	if (!strcmp(action," Save changes "))
	{
		db::Account account(db, pWeb -> GetUsernum());
		account.show_email = atoi(GetForm() -> getvalue("show_email").c_str());
		std::string old = GetForm() -> getvalue("old");
		std::string new_password = GetForm() -> getvalue("new_password");
		std::string new_password2 = GetForm() -> getvalue("new_password2");
		if (!strcmp(old.c_str(),account.secret.c_str()))
		{
			if (new_password.size() >= 4 && !strcmp(new_password.c_str(),new_password2.c_str()))
			{
				account.secret = new_password;
			}
		}
		account.save();
	}
	if (!strcmp(action," Return to forums "))
	{
		pWeb -> SetPage( 3 );
	}
}


void SettingsForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	db::Account account(db, pWeb -> GetUsernum());

//	printf("<h3>User settings</h3>");
	printf("<div class=navigator>");
	printf("<table cellpadding=0 cellspacing=0 width=\"100%%\"><tr><td>");
	printf("<b>Settings</b>");
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=3\">forums</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	printf("<form action=\"%s\" method=post>",GetCgiName().c_str());

	printf("<p><b>Email</b>: %s</p>",account.email.c_str());
	printf("<p><b>Name</b>: %s</p>",account.name.c_str());
	printf("<p>");
	printf("<input type=checkbox name=show_email value=1%s> Show email when posting<br>",
		account.show_email ? " CHECKED" : "");
	printf("</p><p>");
	printf("Enter old password to change<br>");
	printf("<input type=password name=old><br>");
	printf("</p><p>");
	printf("Enter new password<br>");
	printf("<input type=new_password><br>");
	printf("</p><p>");
	printf("Repeat new password<br>");
	printf("<input type=new_password2><br>");
	printf("</p>");
	printf("&nbsp;&nbsp;&nbsp;&nbsp;");
	printf("<input type=submit name=\"%s\" value=\" Save changes \">",GetFormName().c_str());
	printf("&nbsp;&nbsp;&nbsp;&nbsp;");
	printf("<input type=submit name=\"%s\" value=\" Return to forums \">",GetFormName().c_str());
	printf("</form>");
}


